
#ifndef SIXSITEJUMP_H
#define SIXSITEJUMP_H

#include "base.h"

#include <random>
#include <cmath>
#include <array>

namespace motions {
    class SixSiteOctahedron final : public BaseMotion {
    public:
        SixSiteOctahedron(double, double, std::mt19937_64&);
        explicit SixSiteOctahedron(std::mt19937_64&);

        void initialize() override;
        double jump() override;

        [[nodiscard]] std::string toString() const override;

    private:
        const double m_beta{std::acos(-1/3.)};

        std::array<double, 6> m_corners{};
        int m_corner_idx{0};

        std::uniform_int_distribution<> m_chooser{1, 5};

    };
}
#endif //SIXSITEJUMP_H
